Index: binaries/data/mods/public/simulation/components/TechnologyManager.js
===================================================================
--- binaries/data/mods/public/simulation/components/TechnologyManager.js	(revision 0)
+++ binaries/data/mods/public/simulation/components/TechnologyManager.js	(revision 0)
@@ -0,0 +1,312 @@
+function TechnologyManager() {}
+
+TechnologyManager.prototype.Schema =
+	"<a:component type='system'/><empty/>";
+
+TechnologyManager.prototype.Init = function ()
+{
+	var cmpTechTempMan = Engine.QueryInterface(SYSTEM_ENTITY, IID_TechnologyTemplateManager);
+	this.allTechs = cmpTechTempMan.GetAllTechs();
+	this.researchedTechs = {}; // technologies which have been researched
+	this.inProgressTechs = {}; // technologies which are being researched currently
+	
+	// This stores the modifications to unit stats from researched technologies
+	// Example data: {"ResourceGatherer/Rates/food.grain": [ {"multiplier": 1.15, "affects": ["Female", "Infantry Swordsman"]},
+	//                                                      {"add": 2} ]}
+	this.modifications = {};
+	
+	this.typeCounts = {}; // stores the number of entities of each type 
+	this.classCounts = {}; // stores the number of entities of each Class
+	this.typeCountsByClass = {}; // stores the number of entities of each type for each class i.e.
+	                             // {"someClass": {"unit/spearman": 2, "unit/cav": 5} "someOtherClass":...}
+	
+	// Some technologies are automatically researched when their conditions are met.  They have no cost and are 
+	// researched instantly.  This allows civ bonuses and more complicated technologies.
+	this.autoResearchTech = {};
+	for (var key in this.allTechs)
+	{
+		if (this.allTechs[key].autoResearch)
+			this.autoResearchTech[key] = this.allTechs[key];
+	}
+	
+	this._UpdateAutoResearch();
+};
+
+// This function checks if the requirements of any autoresearch techs are met and if they are it researches them
+TechnologyManager.prototype._UpdateAutoResearch = function ()
+{
+	for (var key in this.autoResearchTech)
+	{
+		if (this.CanResearch(key))
+		{
+			delete this.autoResearchTech[key];
+			this.ResearchTechnology(key);
+			return; // We will have recursively handled any knock-on effects so can just return
+		}
+	}
+}
+
+TechnologyManager.prototype.GetTechnologyTemplate = function (tech)
+{
+	return this.allTechs[tech];
+};
+
+// This function checks an entity template to see if it's technology requirements have been met
+TechnologyManager.prototype.CanProduce = function (templateName)
+{
+	var cmpTempManager = Engine.QueryInterface(SYSTEM_ENTITY, IID_TemplateManager);
+	var template = cmpTempManager.GetTemplate(templateName);
+	
+	if (template.Identity && template.Identity.RequiredTechnology)
+		return this.IsTechnologyResearched(template.Identity.RequiredTechnology);
+	else
+		return true; // If there is no required technology then this entity can be produced
+};
+
+TechnologyManager.prototype.IsTechnologyResearched = function (tech)
+{
+	return (this.researchedTechs[tech] !== undefined);
+};
+
+// Checks the requirements for a technology to see if it can be researched at the current time
+TechnologyManager.prototype.CanResearch = function (tech)
+{
+	var template = this.GetTechnologyTemplate(tech);
+	if (!template)
+	{
+		warn("Technology \"" + tech + "\" does not exist");
+		return false;
+	}
+	
+	var ret = true;
+	
+	// The technology which this technology supercedes is required
+	if (template.supercedes)
+		ret = ret && this.IsTechnologyResearched(template.supercedes);
+	
+	ret = ret && this._CheckTechnologyRequirements(template.requirements);
+	
+	return ret;
+};
+
+TechnologyManager.prototype._CheckTechnologyRequirements = function (reqs)
+{
+	// If there are no requirements then all requirements are met
+	if (!reqs)
+		return true;
+	
+	if (reqs.tech)
+	{
+		return this.IsTechnologyResearched(reqs.tech);
+	}
+	else if (reqs.all)
+	{
+		var ret = true;
+		for (var i = 0; i < reqs.all.length; i++)
+		{
+			ret = ret && this._CheckTechnologyRequirements(reqs.all[i]);
+		}
+		return ret;
+	}
+	else if (reqs.any)
+	{
+		for (var i = 0; i < reqs.any.length; i++)
+		{
+			if (this._CheckTechnologyRequirements(reqs.any[i]))
+				return true;
+		}
+		return false
+	}
+	else if (reqs["class"])
+	{
+		return (reqs.numberOfTypes <= Object.keys(this.typeCountsByClass[reqs["class"]]).length);
+	}
+	
+	// The technologies requirements are not a recognised format
+	error("Bad requirements " + uneval(reqs));
+	return false;
+};
+
+TechnologyManager.prototype.OnGlobalOwnershipChanged = function (msg)
+{
+	// This automatically updates typeCounts, classCounts and typeCountsByClass
+	var playerID = (Engine.QueryInterface(this.entity, IID_Player)).GetPlayerID();
+	if (msg.to == playerID)
+	{
+		var cmpTemplateManager = Engine.QueryInterface(SYSTEM_ENTITY, IID_TemplateManager);
+		var template = cmpTemplateManager.GetCurrentTemplateName(msg.entity);
+		
+		this.typeCounts[template] = this.typeCounts[template] || 0;
+		this.typeCounts[template] += 1;
+		
+		// don't use foundations for the class counts
+		if (Engine.QueryInterface(msg.entity, IID_Foundation))
+			return;
+		
+		var cmpIdentity = Engine.QueryInterface(msg.entity, IID_Identity);
+		if (cmpIdentity)
+		{
+			var classes = cmpIdentity.GetClassesList();
+			for (var i in classes)
+			{
+				this.classCounts[classes[i]] = this.classCounts[classes[i]] || 0;
+				this.classCounts[classes[i]] += 1;
+				
+				this.typeCountsByClass[classes[i]] = this.typeCountsByClass[classes[i]] || {};
+				this.typeCountsByClass[classes[i]][template] = this.typeCountsByClass[classes[i]][template] || 0;
+				this.typeCountsByClass[classes[i]][template] += 1;
+			}
+		}
+	}
+	if (msg.from == playerID)
+	{
+		var cmpTemplateManager = Engine.QueryInterface(SYSTEM_ENTITY, IID_TemplateManager);
+		var template = cmpTemplateManager.GetCurrentTemplateName(msg.entity);
+		
+		this.typeCounts[template] -= 1;
+		
+		// don't use foundations for the class counts
+		if (Engine.QueryInterface(msg.entity, IID_Foundation))
+			return;
+		
+		var cmpIdentity = Engine.QueryInterface(msg.entity, IID_Identity);
+		if (cmpIdentity)
+		{
+			var classes = cmpIdentity.GetClassesList();
+			for (var i in classes)
+			{
+				this.classCounts[classes[i]] -= 1;
+				
+				this.typeCountsByClass[classes[i]][template] -= 1;
+			}
+		}
+	}
+};
+	
+// Marks a technology as researched.  Note that this does not verify that the requirements are met.
+TechnologyManager.prototype.ResearchTechnology = function (tech)
+{
+	this.StoppedResearch(tech); // The tech is no longer being currently researched
+	
+	var template = this.GetTechnologyTemplate(tech);
+	if (template)
+	{
+		var modifiedComponents = {};
+		this.researchedTechs[tech] = template;
+		// store the modifications in an easy to access structure
+		if (template.modifications)
+		{
+			var affects = [];
+			if (template.affects && template.affects.length > 0)
+			{
+				for (var i in template.affects)
+				{
+					// Put the list of classes into an array for convenient access
+					affects.push(template.affects[i].split(" "));
+				}
+			}
+			else
+			{
+				affects.push([]);
+			}
+			
+			// We add an item to this.modifications for every 
+			for (var i in template.modifications)
+			{
+				var modification = template.modifications[i];
+				if (!this.modifications[modification.value])
+					this.modifications[modification.value] = [];
+				
+				var mod = {"affects": affects};
+				// copy the modification data into our new data structure
+				for (var j in modification)
+					if (j !== "value")
+						mod[j] = modification[j]
+				
+				this.modifications[modification.value].push(mod);
+				modifiedComponents[modification.value.split("/")[0]] = true;
+			}
+		}
+		
+		var cmpPlayer = Engine.QueryInterface(this.entity, IID_Player);
+		var player = cmpPlayer.GetPlayerID();
+		
+		for (var component in modifiedComponents)
+			Engine.BroadcastMessage(MT_TechnologyModificationChange, { "component": component, "player": player });
+		
+		this._UpdateAutoResearch();
+	}
+	else
+	{
+		error("Tried to research invalid techonology: " + uneval(tech));
+	}
+};
+
+TechnologyManager.prototype.ApplyModifications = function(valueName, curValue, ent)
+{	
+	// Get all modifications to this value
+	var modifications = this.modifications[valueName];
+	if (!modifications) // no modifications so return the orignal value
+		return curValue;
+	
+	// Get the classes which this entity belongs to
+	var cmpIdentity = Engine.QueryInterface(ent, IID_Identity);
+	var classes = cmpIdentity.GetClassesList();
+	
+	var retValue = +curValue;
+	
+	for (var i in modifications)
+	{
+		var modification = modifications[i];
+		var applies = false;
+		// See if any of the lists of classes matches this entity
+		for (var j in modification.affects)
+		{
+			var hasAllClasses = true;
+			// Check each 
+			for (var k in modification.affects[j])
+				hasAllClasses = hasAllClasses && (classes.indexOf(modification.affects[j][k]) !== -1);
+			
+			if (hasAllClasses)
+			{
+				applies = true;
+				break;
+			}
+		}
+		
+		// Nothing is cumulative so that ordering doesn't matter as much as possible
+		if (modification.multiplier)
+			retValue += (modification.multiplier - 1) * +curValue;
+		else if (modification.add)
+			retValue += modification.add;
+		else if (modification.replace) // This will depend on ordering because there is no choice
+			retValue = modification.replace;
+		else
+			warn("modification format not recognised (modifying " + valueName + "): " + uneval(modification));
+	}
+	
+	return retValue;
+};
+
+// Marks a technology as being currently researched
+TechnologyManager.prototype.StartedResearch = function (tech)
+{
+	this.inProgressTechs[tech] = true;
+};
+
+// Marks a technology as not being currently researched
+TechnologyManager.prototype.StoppedResearch = function (tech)
+{
+	delete this.inProgressTechs[tech];
+};
+
+// Checks whether a technology is being currently researched
+TechnologyManager.prototype.IsInProgress = function(tech)
+{
+	if (this.inProgressTechs[tech])
+		return true;
+	else
+		return false;
+};
+
+Engine.RegisterComponentType(IID_TechnologyManager, "TechnologyManager", TechnologyManager);
Index: binaries/data/mods/public/simulation/components/ProductionQueue.js
===================================================================
--- binaries/data/mods/public/simulation/components/ProductionQueue.js	(revision 11375)
+++ binaries/data/mods/public/simulation/components/ProductionQueue.js	(working copy)
@@ -1,23 +1,33 @@
 var g_ProgressInterval = 1000;
 const MAX_QUEUE_SIZE = 16;
 
-function TrainingQueue() {}
+function ProductionQueue() {}
 
-TrainingQueue.prototype.Schema =
-	"<a:help>Allows the building to train new units.</a:help>" +
+ProductionQueue.prototype.Schema =
+	"<a:help>Allows the building to train new units and research technologies.</a:help>" +
 	"<a:example>" +
 		"<Entities datatype='tokens'>" +
 			"\n    units/{civ}_support_female_citizen\n    units/{civ}_support_trader\n    units/celt_infantry_spearman_b\n  " +
 		"</Entities>" +
 	"</a:example>" +
-	"<element name='Entities' a:help='Space-separated list of entity template names that this building can train. The special string \"{civ}\" will be automatically replaced by the building&apos;s four-character civ code'>" +
-		"<attribute name='datatype'>" +
-			"<value>tokens</value>" +
-		"</attribute>" +
-		"<text/>" +
-	"</element>";
+	"<optional>" + 
+		"<element name='Entities' a:help='Space-separated list of entity template names that this building can train. The special string \"{civ}\" will be automatically replaced by the building&apos;s four-character civ code'>" +
+			"<attribute name='datatype'>" +
+				"<value>tokens</value>" +
+			"</attribute>" +
+			"<text/>" +
+		"</element>" +
+	"</optional>" + 
+	"<optional>" + 
+		"<element name='Technologies' a:help='Space-separated list of technology names that this building can research.'>" +
+			"<attribute name='datatype'>" +
+				"<value>tokens</value>" +
+			"</attribute>" +
+			"<text/>" +
+		"</element>" +
+	"</optional>";
 
-TrainingQueue.prototype.Init = function()
+ProductionQueue.prototype.Init = function()
 {
 	this.nextID = 1;
 
@@ -26,14 +36,24 @@
 	//   {
 	//     "id": 1,
 	//     "player": 1, // who paid for this batch; we need this to cope with refunds cleanly
-	//     "template": "units/example",
+	//     "unitTemplate": "units/example",
 	//     "count": 10,
 	//     "resources": { "wood": 100, ... },	// resources per unit, multiply by count to get total
 	//     "population": 1,	// population per unit, multiply by count to get total
-	//     "trainingStarted": false, // true iff we have reserved population
+	//     "productionStarted": false, // true iff we have reserved population
 	//     "timeTotal": 15000, // msecs
 	//     "timeRemaining": 10000, // msecs
 	//   }
+	//   
+	//   {
+	//     "id": 1,
+	//     "player": 1, // who paid for this research; we need this to cope with refunds cleanly
+	//     "technologyTemplate": "example_tech",
+	//     "resources": { "wood": 100, ... },	// resources needed for research
+	//     "productionStarted": false, // true iff production has started
+	//     "timeTotal": 15000, // msecs
+	//     "timeRemaining": 10000, // msecs
+	//   }
 	
 	this.timer = undefined; // g_ProgressInterval msec timer, active while the queue is non-empty
 	
@@ -44,8 +64,11 @@
 /*
  * Returns list of entities that can be trained by this building.
  */
-TrainingQueue.prototype.GetEntitiesList = function()
+ProductionQueue.prototype.GetEntitiesList = function()
 {
+	if (!this.template.Entities)
+		return [];
+	
 	var string = this.template.Entities._string;
 	
 	// Replace the "{civ}" codes with this entity's civ ID
@@ -57,10 +80,56 @@
 };
 
 /*
- * Adds a new batch of identical units to the training queue.
+ * Returns list of technologies that can be researched by this building.
  */
-TrainingQueue.prototype.AddBatch = function(templateName, count, metadata)
+ProductionQueue.prototype.GetTechnologiesList = function()
 {
+	if (!this.template.Technologies)
+		return [];
+	
+	var string = this.template.Technologies._string;
+	
+	var cmpTechMan = QueryOwnerInterface(this.entity, IID_TechnologyManager);
+	if (!cmpTechMan)
+		return [];
+	
+	var techs = string.split(/\s+/);
+	var ret = [];
+	var superceded = {}; // Stores the tech which supercedes the key 
+	
+	// Add any top level technologies to an array which corresponds to the displayed icons
+	// Also store the "children" for the superceding, 
+	for (var i in techs)
+	{
+		var tech = techs[i];
+		var template = cmpTechMan.GetTechnologyTemplate(tech);
+		if (!template.supercedes || techs.indexOf(template.supercedes) === -1)
+			ret.push(tech);
+		else
+			superceded[template.supercedes] = tech;
+	}
+	
+	// Now make researched/in progress techs invisible
+	for (var i in ret)
+	{
+		var tech = ret[i];
+		while (cmpTechMan.IsTechnologyResearched(tech) || cmpTechMan.IsInProgress(tech))
+		{
+			tech = superceded[tech];
+		}
+
+		
+		ret[i] = tech;
+	}
+	
+	return ret;
+};
+
+/*
+ * Adds a new batch of identical units to train or a technology to research to the production queue.
+ */
+ProductionQueue.prototype.AddBatch = function(templateName, type, count, metadata)
+{
 	// TODO: there should probably be a limit on the number of queued batches
 	// TODO: there should be a way for the GUI to determine whether it's going
 	// to be possible to add a batch (based on resource costs and length limits)
@@ -68,62 +137,106 @@
 
 	if (this.queue.length < MAX_QUEUE_SIZE)
 	{
-		// Find the template data so we can determine the build costs
-		var cmpTempMan = Engine.QueryInterface(SYSTEM_ENTITY, IID_TemplateManager);
-		var template = cmpTempMan.GetTemplate(templateName);
-		if (!template)
-			return;
+		
+		if (type == "unit")
+		{
+			// Find the template data so we can determine the build costs
+			var cmpTempMan = Engine.QueryInterface(SYSTEM_ENTITY, IID_TemplateManager);
+			var template = cmpTempMan.GetTemplate(templateName);
+			if (!template)
+				return;
+			
+			// Apply a time discount to larger batches.
+			// TODO: work out what equation we should use here.
+			var timeMult = Math.pow(count, 0.7);
 
-		// Apply a time discount to larger batches.
-		// TODO: work out what equation we should use here.
-		var timeMult = Math.pow(count, 0.7);
+			var time = timeMult * template.Cost.BuildTime;
 
-		var time = timeMult * template.Cost.BuildTime;
+			var totalCosts = {};
+			for each (var r in ["food", "wood", "stone", "metal"])
+				totalCosts[r] = Math.floor(count * template.Cost.Resources[r]);
 
-		var totalCosts = {};
-		for each (var r in ["food", "wood", "stone", "metal"])
-			totalCosts[r] = Math.floor(count * template.Cost.Resources[r]);
+			var population = template.Cost.Population;
+		
+			// TrySubtractResources should report error to player (they ran out of resources)
+			if (!cmpPlayer.TrySubtractResources(totalCosts))
+				return;
 
-		var population = template.Cost.Population;
-	
-		// TrySubtractResources should report error to player (they ran out of resources)
-		if (!cmpPlayer.TrySubtractResources(totalCosts))
+			this.queue.push({
+				"id": this.nextID++,
+				"player": cmpPlayer.GetPlayerID(),
+				"unitTemplate": templateName,
+				"count": count,
+				"metadata": metadata,
+				"resources": deepcopy(template.Cost.Resources), // need to copy to avoid serialization problems
+				"population": population,
+				"productionStarted": false,
+				"timeTotal": time*1000,
+				"timeRemaining": time*1000,
+			});
+		}
+		else if (type == "technology")
+		{
+			// Load the technology template
+			var cmpTechTempMan = Engine.QueryInterface(SYSTEM_ENTITY, IID_TechnologyTemplateManager);
+			var template = cmpTechTempMan.GetTemplate(templateName);
+			if (!template)
+				return;
+			
+			var time = template.researchTime;
+
+			var cost = {};
+			for each (var r in ["food", "wood", "stone", "metal"])
+				cost[r] = Math.floor(template.cost[r]);
+			
+			// TrySubtractResources should report error to player (they ran out of resources)
+			if (!cmpPlayer.TrySubtractResources(cost))
+				return;
+			
+			// Tell the technology manager that we have started researching this so that people can't research the same 
+			// thing twice.
+			var cmpTechMan = QueryOwnerInterface(this.entity, IID_TechnologyManager);
+			cmpTechMan.StartedResearch(templateName);
+
+			this.queue.push({
+				"id": this.nextID++,
+				"player": cmpPlayer.GetPlayerID(),
+				"count": 1,
+				"technologyTemplate": templateName,
+				"resources": deepcopy(template.cost), // need to copy to avoid serialization problems
+				"productionStarted": false,
+				"timeTotal": time*1000,
+				"timeRemaining": time*1000,
+			});
+		}
+		else
+		{
+			warn("Tried to add invalid item of type \"" + type + "\" and template \"" + templateName + "\" to a production queue");
 			return;
+		}
+		
+		Engine.PostMessage(this.entity, MT_ProductionQueueChanged, { });
 
-		this.queue.push({
-			"id": this.nextID++,
-			"player": cmpPlayer.GetPlayerID(),
-			"template": templateName,
-			"count": count,
-			"metadata": metadata,
-			"resources": deepcopy(template.Cost.Resources), // need to copy to avoid serialization problems
-			"population": population,
-			"trainingStarted": false,
-			"timeTotal": time*1000,
-			"timeRemaining": time*1000,
-		});
-		Engine.PostMessage(this.entity, MT_TrainingQueueChanged, { });
-
 		// If this is the first item in the queue, start the timer
 		if (!this.timer)
 		{
 			var cmpTimer = Engine.QueryInterface(SYSTEM_ENTITY, IID_Timer);
-			this.timer = cmpTimer.SetTimeout(this.entity, IID_TrainingQueue, "ProgressTimeout", g_ProgressInterval, {});
+			this.timer = cmpTimer.SetTimeout(this.entity, IID_ProductionQueue, "ProgressTimeout", g_ProgressInterval, {});
 		}
 	}
 	else
 	{
-		var notification = {"player": cmpPlayer.GetPlayerID(), "message": "The training queue is full."};
+		var notification = {"player": cmpPlayer.GetPlayerID(), "message": "The production queue is full."};
 		var cmpGUIInterface = Engine.QueryInterface(SYSTEM_ENTITY, IID_GuiInterface);
 		cmpGUIInterface.PushNotification(notification);
 	}
 };
 
 /*
- * Removes an existing batch of units from the training queue.
+ * Removes an existing batch of units from the production queue.
  * Refunds resource costs and population reservations.
  */
-TrainingQueue.prototype.RemoveBatch = function(id)
+ProductionQueue.prototype.RemoveBatch = function(id)
 {
 	// Destroy any cached entities (those which didn't spawn for some reason)
 	for (var i = 0; i < this.entityCache.length; ++i)
@@ -139,40 +252,48 @@
 			continue;
 
 		// Now we've found the item to remove
-
+		
 		var cmpPlayer = QueryPlayerIDInterface(item.player, IID_Player);
 
 		// Refund the resource cost for this batch
 		var totalCosts = {};
 		for each (var r in ["food", "wood", "stone", "metal"])
 			totalCosts[r] = Math.floor(item.count * item.resources[r]);
-			
+		
 		cmpPlayer.AddResources(totalCosts);
-
+		
 		// Remove reserved population slots if necessary
-		if (item.trainingStarted)
+		if (item.productionStarted && item.unitTemplate)
 			cmpPlayer.UnReservePopulationSlots(item.population * item.count);
-
+		
+		// Mark the research as stopped if we cancel it
+		if (item.technologyTemplate)
+		{
+			var cmpTechMan = QueryOwnerInterface(this.entity, IID_TechnologyManager);
+			cmpTechMan.StoppedResearch(item.technologyTemplate);
+		}
+		
 		// Remove from the queue
 		// (We don't need to remove the timer - it'll expire if it discovers the queue is empty)
 		this.queue.splice(i, 1);
-		Engine.PostMessage(this.entity, MT_TrainingQueueChanged, { });
+		Engine.PostMessage(this.entity, MT_ProductionQueueChanged, { });
 
 		return;
 	}
 };
 
 /*
- * Returns basic data from all batches in the training queue.
+ * Returns basic data from all batches in the production queue.
  */
-TrainingQueue.prototype.GetQueue = function()
+ProductionQueue.prototype.GetQueue = function()
 {
 	var out = [];
 	for each (var item in this.queue)
 	{
 		out.push({
 			"id": item.id,
-			"template": item.template,
+			"unitTemplate": item.unitTemplate,
+			"technologyTemplate": item.technologyTemplate,
 			"count": item.count,
 			"progress": 1-(item.timeRemaining/item.timeTotal),
 			"metadata": item.metadata,
@@ -184,9 +305,9 @@
 /*
  * Removes all existing batches from the queue.
  */
-TrainingQueue.prototype.ResetQueue = function()
+ProductionQueue.prototype.ResetQueue = function()
 {
-	// Empty the training queue and refund all the resource costs
+	// Empty the production queue and refund all the resource costs
 	// to the player. (This is to avoid players having to micromanage their
 	// buildings' queues when they're about to be destroyed or captured.)
 
@@ -194,17 +315,17 @@
 		this.RemoveBatch(this.queue[0].id);
 };
 
-TrainingQueue.prototype.OnOwnershipChanged = function(msg)
+ProductionQueue.prototype.OnOwnershipChanged = function(msg)
 {
 	if (msg.from != -1)
 	{
-		// Unset flag that previous owner's training queue may be blocked
+		// Unset flag that previous owner's training may be blocked
 		var cmpPlayer = QueryPlayerIDInterface(msg.from, IID_Player);
 		if (cmpPlayer && this.queue.length > 0)
-			cmpPlayer.UnBlockTrainingQueue();
+			cmpPlayer.UnBlockTraining();
 	}
 
-	// Reset the training queue whenever the owner changes.
+	// Reset the production queue whenever the owner changes.
 	// (This should prevent players getting surprised when they capture
 	// an enemy building, and then loads of the enemy's civ's soldiers get
 	// created from it. Also it means we don't have to worry about
@@ -212,7 +333,7 @@
 	this.ResetQueue();
 };
 
-TrainingQueue.prototype.OnDestroy = function()
+ProductionQueue.prototype.OnDestroy = function()
 {
 	// Reset the queue to refund any resources
 	this.ResetQueue();
@@ -228,7 +349,7 @@
  * This function creates the entities and places them in world if possible.
  * returns the number of successfully spawned entities.
  */
-TrainingQueue.prototype.SpawnUnits = function(templateName, count, metadata)
+ProductionQueue.prototype.SpawnUnits = function(templateName, count, metadata)
 {
 	var cmpFootprint = Engine.QueryInterface(this.entity, IID_Footprint);
 	var cmpPosition = Engine.QueryInterface(this.entity, IID_Position);
@@ -302,10 +423,10 @@
 };
 
 /*
- * Increments progress on the first batch in the training queue, and blocks the
+ * Increments progress on the first batch in the production queue, and blocks the
  * queue if population limit is reached or some units failed to spawn.
  */
-TrainingQueue.prototype.ProgressTimeout = function(data)
+ProductionQueue.prototype.ProgressTimeout = function(data)
 {
 	// Allocate the 1000msecs to as many queue items as it takes
 	// until we've used up all the time (so that we work accurately
@@ -316,24 +437,28 @@
 	while (time > 0 && this.queue.length)
 	{
 		var item = this.queue[0];
-		if (!item.trainingStarted)
+		if (!item.productionStarted)
 		{
-			// Batch's training hasn't started yet.
-			// Try to reserve the necessary population slots
-			if (!cmpPlayer.TryReservePopulationSlots(item.population * item.count))
+			// If the item is a unit then do population checks
+			if (item.unitTemplate)
 			{
-				// No slots available - don't train this batch now
-				// (we'll try again on the next timeout)
+				// Batch's training hasn't started yet.
+				// Try to reserve the necessary population slots
+				if (item.unitTemplate && !cmpPlayer.TryReservePopulationSlots(item.population * item.count))
+				{
+					// No slots available - don't train this batch now
+					// (we'll try again on the next timeout)
 
-				// Set flag that training queue is blocked
-				cmpPlayer.BlockTrainingQueue();
-				break;
+					// Set flag that training is blocked
+					cmpPlayer.BlockTraining();
+					break;
+				}
+				
+				// Unset flag that training is blocked
+				cmpPlayer.UnBlockTraining();
 			}
 
-			// Unset flag that training queue is blocked
-			cmpPlayer.UnBlockTrainingQueue();
-
-			item.trainingStarted = true;
+			item.productionStarted = true;
 		}
 
 		// If we won't finish the batch now, just update its timer
@@ -343,42 +468,53 @@
 			break;
 		}
 
-		var numSpawned = this.SpawnUnits(item.template, item.count, item.metadata);
-		if (numSpawned == item.count)
+		if (item.unitTemplate)
 		{
-			// All entities spawned, this batch finished
-			cmpPlayer.UnReservePopulationSlots(item.population * numSpawned);
-			time -= item.timeRemaining;
-			this.queue.shift();
-			// Unset flag that training queue is blocked
-			cmpPlayer.UnBlockTrainingQueue();
-			this.spawnNotified = false;
-			Engine.PostMessage(this.entity, MT_TrainingQueueChanged, { });
-		}
-		else
-		{
-			if (numSpawned > 0)
+			var numSpawned = this.SpawnUnits(item.unitTemplate, item.count, item.metadata);
+			if (numSpawned == item.count)
 			{
-				// Only partially finished
+				// All entities spawned, this batch finished
 				cmpPlayer.UnReservePopulationSlots(item.population * numSpawned);
-				item.count -= numSpawned;
-				Engine.PostMessage(this.entity, MT_TrainingQueueChanged, { });
+				time -= item.timeRemaining;
+				this.queue.shift();
+				// Unset flag that training is blocked
+				cmpPlayer.UnBlockTraining();
+				this.spawnNotified = false;
+				Engine.PostMessage(this.entity, MT_ProductionQueueChanged, { });
 			}
+			else
+			{
+				if (numSpawned > 0)
+				{
+					// Only partially finished
+					cmpPlayer.UnReservePopulationSlots(item.population * numSpawned);
+					item.count -= numSpawned;
+					Engine.PostMessage(this.entity, MT_ProductionQueueChanged, { });
+				}
 
-			// Some entities failed to spawn
-			// Set flag that training queue is blocked
-			cmpPlayer.BlockTrainingQueue();
-			
-			if (!this.spawnNotified)
-			{
-				var cmpPlayer = QueryOwnerInterface(this.entity, IID_Player);
-				var notification = {"player": cmpPlayer.GetPlayerID(), "message": "Can't find free space to spawn trained units" };
-				var cmpGUIInterface = Engine.QueryInterface(SYSTEM_ENTITY, IID_GuiInterface);
-				cmpGUIInterface.PushNotification(notification);
-				this.spawnNotified = true;
+				// Some entities failed to spawn
+				// Set flag that training is blocked
+				cmpPlayer.BlockTraining();
+				
+				if (!this.spawnNotified)
+				{
+					var cmpPlayer = QueryOwnerInterface(this.entity, IID_Player);
+					var notification = {"player": cmpPlayer.GetPlayerID(), "message": "Can't find free space to spawn trained units" };
+					var cmpGUIInterface = Engine.QueryInterface(SYSTEM_ENTITY, IID_GuiInterface);
+					cmpGUIInterface.PushNotification(notification);
+					this.spawnNotified = true;
+				}
+				break;
 			}
-			break;
 		}
+		else if (item.technologyTemplate)
+		{
+			var cmpTechnologyManager = QueryOwnerInterface(this.entity, IID_TechnologyManager);
+			cmpTechnologyManager.ResearchTechnology(item.technologyTemplate);
+			
+			this.queue.shift();
+			Engine.PostMessage(this.entity, MT_ProductionQueueChanged, { });
+		}
 	}
 
 	// If the queue's empty, delete the timer, else repeat it
@@ -386,15 +522,15 @@
 	{
 		this.timer = undefined;
 
-		// Unset flag that training queue is blocked
+		// Unset flag that training is blocked
 		// (This might happen when the player unqueues all batches)
-		cmpPlayer.UnBlockTrainingQueue();
+		cmpPlayer.UnBlockTraining();
 	}
 	else
 	{
 		var cmpTimer = Engine.QueryInterface(SYSTEM_ENTITY, IID_Timer);
-		this.timer = cmpTimer.SetTimeout(this.entity, IID_TrainingQueue, "ProgressTimeout", g_ProgressInterval, data);
+		this.timer = cmpTimer.SetTimeout(this.entity, IID_ProductionQueue, "ProgressTimeout", g_ProgressInterval, data);
 	}
 }
 
-Engine.RegisterComponentType(IID_TrainingQueue, "TrainingQueue", TrainingQueue);
+Engine.RegisterComponentType(IID_ProductionQueue, "ProductionQueue", ProductionQueue);
Index: binaries/data/mods/public/simulation/components/TechnologyTemplateManager.js
===================================================================
--- binaries/data/mods/public/simulation/components/TechnologyTemplateManager.js	(revision 0)
+++ binaries/data/mods/public/simulation/components/TechnologyTemplateManager.js	(revision 0)
@@ -0,0 +1,39 @@
+/**
+ * System component which loads the technology data files
+ */
+function TechnologyTemplateManager() {}
+
+TechnologyTemplateManager.prototype.Schema =
+	"<a:component type='system'/><empty/>";
+	
+TechnologyTemplateManager.prototype.Init = function()
+{
+	this.allTechs = {};
+	var techNames = this.ListAllTechs();
+	for (i in techNames)
+		this.GetTemplate(techNames[i]);
+};
+
+TechnologyTemplateManager.prototype.GetTemplate = function(template)
+{
+	if (!this.allTechs[template])
+	{
+		this.allTechs[template] = Engine.ReadJSONFile("technologies/" + template + ".json");
+		if (! this.allTechs[template])
+			error("Failed to load technology \"" + template + "\"");
+	}
+	
+	return this.allTechs[template];
+};
+
+TechnologyTemplateManager.prototype.ListAllTechs = function()
+{
+	return Engine.FindAllTechnologyTemplates();
+}
+
+TechnologyTemplateManager.prototype.GetAllTechs = function()
+{
+	return this.allTechs;
+}
+
+Engine.RegisterComponentType(IID_TechnologyTemplateManager, "TechnologyTemplateManager", TechnologyTemplateManager);
\ No newline at end of file
Index: binaries/data/mods/public/simulation/ai/common-api/base.js
===================================================================
--- binaries/data/mods/public/simulation/ai/common-api/base.js	(revision 11571)
+++ binaries/data/mods/public/simulation/ai/common-api/base.js	(working copy)
@@ -43,7 +43,7 @@
 // CCmpTemplateManager::CopyFoundationSubset and only includes components
 // that our EntityTemplate class currently uses.)
 var g_FoundationForbiddenComponents = {
-	"TrainingQueue": 1,
+	"ProductionQueue": 1,
 	"ResourceSupply": 1,
 	"ResourceDropsite": 1,
 	"GarrisonHolder": 1,
